/// This file is inspired from gesture_x_detector.dart from the [gesture_x_detector](https://github.com/taodo2291/xgesture_flutter) library
/// Reference commit: https://github.com/taodo2291/xgesture_flutter/tree/f57721bed8194021f36b3e454ef7b828bf259c53

import 'dart:async';

import 'package:flutter/gestures.dart';
import 'package:flutter/widgets.dart';


class a126 {
  
  final Offset a108;

  
  final Offset a107;

  
  final Offset a106;

  
  a126._a198(_a129 a469)
      : a108 = a469.a91,
        a107 = a469.a90 - a469.a91,
        a106 =
            a469.a89.getVelocityEstimate()?.pixelsPerSecond ??
                Offset.zero;
}

/// Signature for listening to tap events.
typedef TapEventListener = void Function(PointerEvent event);

/// Signature for listening to move events.
typedef MoveEventListener = void Function(a126 event);


class a127 extends StatefulWidget {
  
  const a127({
    Key? a470,
    required this.a105,
    this.a104,
    this.a103,
    this.a102,
    this.a101,
    this.a100,
    this.a99,
    this.a97 = kLongPressTimeout,
    this.a98 = kTouchSlop,
    this.a96 = true,
  }) : super(key: a470);

  
  final Widget a105;

  
  final TapEventListener? a104;

  
  final TapEventListener? a103;

  
  final Function()? a102;

  
  final MoveEventListener? a101;

  
  final MoveEventListener? a100;

  
  final MoveEventListener? a99;

  
  final double a98;

  
  final Duration a97;

  
  final bool a96;

  @override
  _a130 createState() => _a130();
}

enum _a128 {
  a95,
  a94,
  a93,
  a92,
}

class _a129 {
  late Offset a91;
  late Offset a90;
  late VelocityTracker a89;

  Offset get a7 => a90 - a91;

  _a129.a199(PointerEvent a471) {
    a91 = a471.localPosition;
    a90 = a91;
    a89 = VelocityTracker.withKind(a471.kind)
      ..addPosition(a471.timeStamp, a471.position);
  }
}

class _a130 extends State<a127> {
  final Map<int, _a129> _a292 = <int, _a129>{};
  _a128 a88 = _a128.a92;
  Timer? a87;
  Offset a86 = Offset.zero;

  @override
  Widget build(BuildContext context) {
    return Listener(
      behavior: HitTestBehavior.translucent,
      child: widget.a105,
      onPointerDown: a33,
      onPointerUp: a30,
      onPointerMove: a32,
      onPointerCancel: a29,
    );
  }

  @override
  void dispose() {
    _a201();
    _a292.clear();
    super.dispose();
  }

  void _a200(int a472) {
    _a292.remove(a472);
  }

  void a33(PointerDownEvent a449) {
    _a292[a449.pointer] = _a129.a199(a449);

    if (a6 == 1) {
      a88 = _a128.a95;
      a28(a449);
    } else {
      a88 = _a128.a92;
    }
  }

  void a32(PointerMoveEvent a448) {
    final a293 = _a292[a448.pointer];

    if (a293 == null) return;

    a293.a90 = a448.localPosition;

    if (!a27(a293)) {
      _a201();
    }

    switch (a88) {
      case _a128.a93:
        if (widget.a96) {
          a293.a91 = a293.a90;
        } else {
          a31(a293, a448);
        }
        break;
      case _a128.a95:
        a31(a293, a448);
        break;
      case _a128.a94:
        a293.a89.addPosition(a448.timeStamp, a448.position);
        widget.a100?.call(a126._a198(a293));
        break;

      default:
        a293.a91 = a293.a90;
        break;
    }
  }

  void a31(_a129 a446, PointerMoveEvent a447) {
    a446.a90 = a447.localPosition;
    if (!a27(a446)) {
      a88 = _a128.a94;
      widget.a101?.call(a126._a198(a446));
    }
  }

  void a30(PointerUpEvent a445) {
    final a294 = _a292[a445.pointer];
    if (a294 == null) return;

    a294.a90 = a445.position;
    if (a88 == _a128.a95) {
      a26(a445.copyWith(position: a294.a91));
    } else if (a88 == _a128.a94) {
      a88 = _a128.a92;
      a294.a89.addPosition(a445.timeStamp, a445.position);

      widget.a99?.call(a126._a198(a294));
    } else if (a88 == _a128.a93) {
      widget.a102?.call();
      a88 = _a128.a92;
    } else {
      a88 = _a128.a92;
    }

    a86 = a445.localPosition;
    _a200(a445.pointer);
  }

  void a29(PointerCancelEvent a444) =>
      _a200(a444.pointer);

  void a28(PointerEvent a443) {
    if (widget.a103 != null) {
      a87?.cancel();
      a87 = Timer(widget.a97, () {
        if (a6 == 1 && _a292.entries.first.key == a443.pointer) {
          a88 = _a128.a93;
          widget.a103!(a443);
          _a201();
        }
      });
    }
  }

  bool a27(_a129 a442) {
    return a442.a7.distance.abs() <= widget.a98;
  }

  void _a201() {
    a87?.cancel();
    a87 = null;
  }

  void a26(PointerEvent a441) {
    widget.a104?.call(a441);
  }

  get a6 => _a292.length;
}
