import 'dart:collection';
import 'dart:convert';

import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

import '../webview_tracking/webview_tracking.dart';
import 'compression.dart';
import 'element_tree.dart';
import 'render_object_extension.dart';
import 'widgets_binding.dart';


RenderView a234() {
  return a180.a203!.renderView;
}


Future<String> a235({
  required String a503,
  required double a504,
}) async {
  final a339 = _a236();

  final a340 = await a339.a21(
    a435: a504,
    
    a436: null,
    a437: a503,
  );

  
  
  a340[0]['style']['bmp'] =
      'com_contentsquare_rootViewBitmapPlaceholder';

  return json.encode(a340);
}


a143 _a236() {
  final a341 = a234();

  final a342 = a196();

  final a343 = _a240(
    a509: a341,
    a510: a342,
  );

  
  
  return a343!;
}


class a143 {
  
  a143({
    required this.a64,
    required this.a63,
    required this.a62,
    required this.a61,
    required this.a60,
  }) : assert(
          a64.a226 == a63,
          'The global frame of the render object must match the global frame of the node',
        );

  
  final RenderObject a64;

  
  final Rect a63;

  
  final String a62;

  
  final Widget a61;

  
  final UnmodifiableListView<a143> a60;

  
  String get a4 => '${a61.runtimeType}';

  
  Future<UnmodifiableListView<Map<String, dynamic>>> a21({
    required double a435,
    required Rect? a436,
    required String a437,
  }) async {
    assert(
      () {
        final a344 = a64 == a234();

        return (a344 && a436 == null) ||
            (!a344 && a436 != null);
      }(),
      'The parent global frame must be null if and only if this is the root node',
    );

    Future<UnmodifiableListView<Map<String, dynamic>>>
        a237() async {
      return UnmodifiableListView([
        for (final a345 in a60)
          ...await a345.a21(
            a435: a435,
            a436: a63,
            a437: a437,
          )
      ]);
    }

    
    
    
    final a346 = a239(
      a507: a64,
      a508: a436,
    );
    if (!a346) {
      return a237();
    }

    /// A function which executes:
    ///   - [callback] if [renderObject] is associated to a WebView
    ///   - [orElse] otherwise
    T a238<T>(
      T Function(a136 webViewTrackerRenderObject)
          a505, {
      required T Function() a506,
    }) {
      final a347 = this.a64;

      if (a347 is a136) {
        return a505(a347);
      } else {
        return a506();
      }
    }

    return UnmodifiableListView([
      {
        'id': a4,
        'metadata': {
          'class_name': a4,
          
          
          'fullpath': a437 + a193(a62),
        },

        /// "recordingId" should only be mandatory for session replay
        /// On the iOS SDK, the structure is used for both: snapshoting and session replay features
        /// so it ends up mandatory for the screengraph passed down to the ExternalBridgeInterface.takeSnapshot completion
        /// For this reason, we set temporarily a 'recordingId' value based on the widget's runtimeType.
        /// TODO: This will need to be checked and discussed when implementing session replay related features
        'recordingId': a4,
        'style': {
          'height': a63.height * a435,
          'width': a63.width * a435,
          'x': a63.left * a435,
          'y': a63.top * a435,
          'visibility': true,
        },
        
        
        'format': a238((_) => 2, a506: () => 1),
        'children': await a238(
          (webViewTrackerRenderObject) async => [
            await webViewTrackerRenderObject.a73(),
          ],
          a506: () => a237(),
        ),
      },
    ]);
  }
}


bool a239({
  required RenderObject a507,
  required Rect? a508,
}) {
  final a348 = a507.a226 != null &&
      a508 != a507.a226;

  final a349 =
      a507 is a136;

  return a348 || a349;
}


a143? _a240({
  required RenderObject a509,
  required a125 a510,
}) {
  assert(
    a510.a111 == a509,
    '	_getPaintedRenderObjectNode was called with a [ElementNode] in which the '
    'renderObject does not match the given [paintedRenderObject]',
  );

  final a350 = a509.a227;
  final a351 = a509.a226;

  
  
  
  
  
  if (a350 == null || a351 == null) {
    return null;
  }

  final a352 = <a143>[];
  
  
  final a353 = LayerHandle<ContainerLayer>();
  a353.layer = ContainerLayer();

  final a354 = _a144(
    a353.layer!,
    a350,
  );

  
  
  
  a509.paint(a354, Offset.zero);

  
  a353.layer = null;

  
  final a355 = a354.a3;
  for (final a356 in a355) {
    final a357 = _a241(
      a513: a356,
      a514: a510,
    );

    
    
    
    
    
    
    
    
    if (a357 != null) {
      final a358 = _a240(
        a509: a356,
        a510: a357,
      );

      if (a358 != null) {
        a352.add(a358);
      }
    }
  }

  
  
  
  
  
  a509.markNeedsPaint();

  return a143(
    a64: a509,
    a63: a351,
    a61: a510.a112,
    a62: a510.a110,
    a60: UnmodifiableListView(a352),
  );
}


class _a144 extends PaintingContext {
  _a144(
    ContainerLayer a511,
    Rect a512, {
    this.a59,
  }) : super(a511, a512);

  
  UnmodifiableListView<RenderObject> get a3 =>
      UnmodifiableListView<RenderObject>(_a359);

  
  final List<RenderObject> _a359 = <RenderObject>[];

  /// This is what is called by a [renderObject] to paint a child.
  @override
  void paintChild(RenderObject child, Offset offset) {
    _a359.add(child);
    a59?.call(child);

    
  }

  
  final void Function(RenderObject child)? a59;

  /// Some render object use [_a144.pushLayer] to paint their
  /// children. This calls [createChildContext] to create a new context on which
  /// the render object will paint its child.
  /// Therefore we need to also return an [_a144] which will
  /// report to this [_a144] the children that tried to be
  /// painted.
  @override
  _a144 createChildContext(
    ContainerLayer childLayer,
    Rect bounds,
  ) {
    return _a144(
      childLayer,
      bounds,
      a59: _a359.add,
    );
  }
}


a125? _a241({
  required RenderObject a513,
  required a125 a514,
}) {
  final a360 = a514;

  
  
  final a361 = List.of([a360]);
  while (a361.isNotEmpty) {
    final a362 = a361.removeAt(0);
    if (a362.a111 == a513) {
      return a362;
    }

    a361.addAll(a362.a109);
  }

  return null;
}
