import 'dart:convert';

import 'package:contentsquare/contentsquare.dart';
import 'package:contentsquare/src/obfuscation/keep.dart';
import 'package:flutter/foundation.dart';

import 'adapters/adapters.dart';

/// The type of event that is sent from the webview.
@a271
enum ContentsquareJavascriptEventEnum {
  /// Send a pageView event or any kind of gesture.
  sendEvent,

  /// Send an exception.
  sendException,

  /// Send a message.
  sendMessage,

  /// Opt in.
  optIn,

  /// Opt out.
  optOut,

  /// Send transaction.
  sendTransaction,

  /// Send dynamic var.
  sendDynamicVar,
}


const _a365 =
    'CSJavascriptBridge_FlutterJavascriptChannel_';


@visibleForTesting
class a147 {
  
  a147({
    required this.a57,
    required this.a56,
    required this.a55,
  });

  
  final Contentsquare a57;

  
  final ContentsquareJavascriptEventEnum a56;

  
  String get _a246 =>
      '$_a365${a56.name}';

  
  final String? Function() a55;

  
  JavascriptChannel get a1 {
    return JavascriptChannel(
      name: _a246,
      onMessageReceived: (message) async {
        return _a247(message);
      },
    );
  }

  
  Future<void> _a247(String a521) {
    final a366 = jsonDecode(a521) as Map<String, dynamic>;
    return _a248(a57).a12(a366);
  }

  a166 _a248(Contentsquare a522) {
    switch (a56) {
      case ContentsquareJavascriptEventEnum.sendEvent:
        return a157(
          a51: a522,
          a50: a55,
        );
      case ContentsquareJavascriptEventEnum.sendException:
        return a163(a47: a522);
      case ContentsquareJavascriptEventEnum.sendMessage:
        return a162(a48: a522);
      case ContentsquareJavascriptEventEnum.optIn:
        return a148(a54: a522);
      case ContentsquareJavascriptEventEnum.optOut:
        return a150(a53: a522);
      case ContentsquareJavascriptEventEnum.sendTransaction:
        return a164(a46: a522);
      case ContentsquareJavascriptEventEnum.sendDynamicVar:
        return a165(a45: a522);
    }
  }

  
  String a20({
    required String Function(String channelName, String data)
        a434,
  }) =>
      '''
function (${_a248(a57).a0.map((name) => name).join(', ')}) {
  ${a434(_a246, 'JSON.stringify({${_a248(a57).a0.map((name) => '"$name": $name').join(', ')}})')};
}''';
}
